﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Xml;

namespace GestorDatosGalindo
{
    public partial class Principal : Form
    {

        public static string connectionString = GestorDatosGalindo.Properties.Settings.Default.connectionString;


        private Steema.TeeChart.Editor chartEditor;

        public static int imgBLANCO = 1;
        public static int imgLI = 1;
        public static int imgAF = 2;
        public static int imgCA = 4;
        public static int imgCO = 5;
        public static int imgAC = 6;
        public static int imgCAT = 7;
 

        public Principal()
        {
            InitializeComponent();
            con.ConnectionString = connectionString;

           //MessageBox.Show(connectionString);
            chartEditor = new Steema.TeeChart.Editor();
            chartEditor.CloseEditor += new EventHandler(editor_CloseEditor);
        }

        private void editor_CloseEditor(object sender, EventArgs e)
        {
            if (this.ActiveMdiChild.Name.Equals("frmGrafica"))
            {
                frmGrafica graf = (frmGrafica)this.ActiveMdiChild;
                graf.repasarGridSeries();
            }
        }
        private void ShowNewForm(object sender, EventArgs e)
        {
            frmGrafica childForm = new frmGrafica();
            childForm.MdiParent = this;
            //childForm.Text = "Gráfica : Sin título";
            childForm.Show();
        }

        private void OpenFile(object sender, EventArgs e)
        {
            openToolStripButton_Click(null, null);
        }

        private void SaveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            saveFileDialog.Filter = "Text Files (*.txt)|*.txt|All Files (*.*)|*.*";
            if (saveFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                string FileName = saveFileDialog.FileName;
            }
        }

        private void ExitToolsStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void CutToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void CopyToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void PasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
        }

        private void ToolBarToolStripMenuItem_Click(object sender, EventArgs e)
        {
           
        }

        private void StatusBarToolStripMenuItem_Click(object sender, EventArgs e)
        {
     
        }

        private void CascadeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.Cascade);
        }

        private void TileVerticalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileVertical);
        }

        private void TileHorizontalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileHorizontal);
        }

        private void ArrangeIconsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.ArrangeIcons);
        }

        private void CloseAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (Form childForm in MdiChildren)
            {
                childForm.Close();
            }
        }

        private void Principal_MdiChildActivate(object sender, EventArgs e)
        {
            /************ TSPRINCIPAL*********************************/
            {
                // remove any previously-merged toolstrips
                ToolStripManager.RevertMerge(tsPrincipal);

                // get child toolstrip
                ToolStrip ChildToolStrip = null;
                ToolStrip ChildToolStrip2 = null;

                if (this.ActiveMdiChild != null)
                {
                    if (this.ActiveMdiChild.Name == "frmGrafica")
                    {
                        frmGrafica f = ((frmGrafica)ActiveMdiChild);
                        //f.chartController.Chart = f.chart;
                        //ChildToolStrip2 = f.chartController;

                        chartController.Chart = f.chart;
                        chartController.Visible = true;
                        chartEditor.Chart = f.chart;
                        chartController.Editor = chartEditor;
                        //ChildToolStrip2 = chartController;

                        ChildToolStrip = f.tsGrafica;
                    }
                    
                    else 
                        chartController.Visible = false;

                }
                else
                    chartController.Visible = false;

                // merge it, if present
                if (ChildToolStrip != null)
                {
                    ToolStripManager.Merge(ChildToolStrip, tsPrincipal);
                }
                if (ChildToolStrip2 != null)
                {
                    ToolStripManager.Merge(ChildToolStrip2, tsPrincipal);
                }
            }
           


            /************ TSAUX*********************************/
            {
                // remove any previously-merged toolstrips
                ToolStripManager.RevertMerge(tsAux);

                // get child toolstrip
                ToolStrip ChildToolStrip = null;
                ToolStrip ChildToolStrip2 = null;

                if (this.ActiveMdiChild != null)
                {
                    if (this.ActiveMdiChild.Name == "frmGrafica")
                    {
                        frmGrafica f = ((frmGrafica)ActiveMdiChild);
                        //ChildToolStrip2 = f.chartController;

                     
                    }


                }

                // merge it, if present
                if (ChildToolStrip != null)
                {
                    ToolStripManager.Merge(ChildToolStrip, tsAux);
                    tsAux.Visible = true;
                    toolStripContainer1.Height = 49;
                }
                else
                {
                    toolStripContainer1.Height = 25;
                    tsAux.Visible = false;
                }
                if (ChildToolStrip2 != null)
                {
                    ToolStripManager.Merge(ChildToolStrip2, tsPrincipal);

                }
            }

        }


        private void refrescarRecent()
        {
            if (GestorDatosGalindo.Properties.Settings.Default.recent1.Equals(""))
            {
                tsRecent1.Enabled = false;
                tsRecent1.Text = "...";
            }
            else
            {
                tsRecent1.Enabled = true;
                tsRecent1.Tag = GestorDatosGalindo.Properties.Settings.Default.recent1;
                tsRecent1.Text = GestorDatosGalindo.Properties.Settings.Default.recent1;
            }
            if (GestorDatosGalindo.Properties.Settings.Default.recent2.Equals(""))
            {
                tsRecent2.Enabled = false;
                tsRecent2.Text = "...";
            }
            else
            {
                tsRecent2.Enabled = true;
                tsRecent2.Tag = GestorDatosGalindo.Properties.Settings.Default.recent2;
                tsRecent2.Text = GestorDatosGalindo.Properties.Settings.Default.recent2;
            }
            if (GestorDatosGalindo.Properties.Settings.Default.recent3.Equals(""))
            {
                tsRecent3.Enabled = false;
                tsRecent3.Text = "...";
            }
            else
            {
                tsRecent3.Enabled = true;
                tsRecent3.Tag = GestorDatosGalindo.Properties.Settings.Default.recent3;
                tsRecent3.Text = GestorDatosGalindo.Properties.Settings.Default.recent3;
            }
            if (GestorDatosGalindo.Properties.Settings.Default.recent4.Equals(""))
            {
                tsRecent4.Enabled = false;
                tsRecent4.Text = "...";
            }
            else
            {
                tsRecent4.Enabled = true;
                tsRecent4.Tag = GestorDatosGalindo.Properties.Settings.Default.recent4;
                tsRecent4.Text = GestorDatosGalindo.Properties.Settings.Default.recent4;
            }
        }

        private void Principal_Load(object sender, EventArgs e)
        {
            toolStripContainer1.Height = 25;
            Steema.TeeChart.Languages.Spanish.Activate();

            refrescarRecent();

            bool error = false;

            

        }

        public void cargarCategorias()
        {

        }

        public void cargarVariablesTemporales()
        {

        }

        public void cargarAcumuladas()
        {

        }



        private void openToolStripButton_Click(object sender, EventArgs e)
        {
            DialogResult res = openDialog.ShowDialog();
            if (res.Equals(DialogResult.OK))
            {
                Application.DoEvents();
                abrir(openDialog.FileName);       
            }
        }


        private void abrir(string path)
        {
            if (System.IO.File.Exists(path))
            {
                this.Cursor = Cursors.WaitCursor;

                // Comprobar tipo de gráfica
                XmlDocument xml = new XmlDocument();
                xml.Load(path);
                if (xml.FirstChild.Name.Equals("grafica"))
                {
                    frmGrafica childForm = new frmGrafica(path);
                    childForm.MdiParent = this;
                    childForm.Show();
                }

                recentAgregar(path);
                this.Cursor = Cursors.Default;
            }
            else
            {
                MessageBox.Show("El archivo no existe", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        public void recentAgregar(string path)
        {
            if (!GestorDatosGalindo.Properties.Settings.Default.recent1.Equals(path))
            {
                GestorDatosGalindo.Properties.Settings.Default.recent4 = GestorDatosGalindo.Properties.Settings.Default.recent3;
                GestorDatosGalindo.Properties.Settings.Default.recent3 = GestorDatosGalindo.Properties.Settings.Default.recent2;
                GestorDatosGalindo.Properties.Settings.Default.recent2 = GestorDatosGalindo.Properties.Settings.Default.recent1;
                GestorDatosGalindo.Properties.Settings.Default.recent1 = path;
                GestorDatosGalindo.Properties.Settings.Default.Save();
                refrescarRecent();
            }

        }

        private void optionsToolStripMenuItem_Click(object sender, EventArgs e)
        {
  
        }

        private void Principal_FormClosed(object sender, FormClosedEventArgs e)
        {
            string archivos="";
            for (int i = 0; i < this.MdiChildren.Length; i++)
            {
                if (this.MdiChildren[i].Name.Equals("frmGrafica"))
                {
                    frmGrafica frm = (frmGrafica)this.MdiChildren[i];
                    if (!frm.path.Equals(""))
                        archivos = archivos + "\t" + frm.path;
                }


            }

            GestorDatosGalindo.Properties.Settings.Default.archivosAbiertos = archivos;
            GestorDatosGalindo.Properties.Settings.Default.Save();

        }

      
        private void toolStripContainer1_TopToolStripPanel_Resize(object sender, EventArgs e)
        {
            toolStripContainer1.Height= toolStripContainer1.TopToolStripPanel.Height;
        }



        private void newAcumuladas_Click(object sender, EventArgs e)
        {

        }

        private void nuevoAcumuladaTS_Click(object sender, EventArgs e)
        {
            newAcumuladas_Click(null, null);
        }

        private void tsAgregarFavorito_Click(object sender, EventArgs e)
        {


        }

        private void tsOrganizarFavorito_Click(object sender, EventArgs e)
        {

        }


       

        private void tsAbrirArchivo_Click(object sender, EventArgs e)
        {
            
        }


    }
}
